Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 4901)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1)
@@ -1499,330 +1023,150 @@
 
 #if defined( __parallel )
-                   IF ( netcdf_data_format > 4 )  THEN
-!
-!--                   Output in netCDF4/HDF5 format.
-!--                   Output only on those PEs where the respective cross sections reside. Cross
-!--                   sections averaged along y are output on the respective first PE along y
-!--                   (myidy=0).
-                      IF ( ( section(is,s_ind) >= nys .AND. section(is,s_ind) <= nyn )  .OR.       &
-                           ( section(is,s_ind) == -1 .AND. myidy == 0 ) )  THEN
-#if defined( __netcdf )
-!
-!--                      For parallel output, all cross sections are first stored here on a local
-!--                      array and will be written to the output file afterwards to increase the
-!--                      performance.
-                         DO  i = nxl, nxr
-                            DO  k = nzb_do, nzt_do
-                               local_2d_sections_l(i,is,k) = local_2d(i,k)
-                            ENDDO
+                   IF ( data_output_2d_on_each_pe )  THEN
+!
+!--                   Output of partial arrays on each PE. If the cross section 
+!--                   does not reside on the PE, output special index values.
+#if defined( __netcdf )
+                      IF ( netcdf_output  .AND.  myid == 0 )  THEN
+                         WRITE ( 23 )  simulated_time, do2d_yz_time_count(av), &
+                                       av
+                      ENDIF
+#endif
+                      IF ( ( section(is,s)>=nxl .AND. section(is,s)<=nxr ) .OR.&
+                           ( section(is,s) ==  -1  .AND.  nxl-1 == -1 ) )      &
+                      THEN
+                         WRITE (23)  nys-1, nyn+1, nzb, nzt+1
+                         WRITE (23)  local_2d
+                      ELSE
+                         WRITE (23)  -1, -1, -1, -1
+                      ENDIF
+
+                   ELSE
+!
+!--                   PE0 receives partial arrays from all processors of the 
+!--                   respective cross section and outputs them. Here a
+!--                   barrier has to be set, because otherwise 
+!--                   "-MPI- FATAL: Remote protocol queue full" may occur.
+                      CALL MPI_BARRIER( comm2d, ierr )
+
+                      ngp = ( nyn-nys+3 ) * ( nzt-nzb+2 )
+                      IF ( myid == 0 )  THEN
+!
+!--                      Local array can be relocated directly.
+                         IF ( ( section(is,s)>=nxl .AND. section(is,s)<=nxr )  &
+                           .OR. ( section(is,s) ==  -1  .AND.  nxl-1 == -1 ) ) &
+                         THEN
+                            total_2d(nys-1:nyn+1,nzb:nzt+1) = local_2d
+                         ENDIF
+!
+!--                      Receive data from all other PEs.
+                         DO  n = 1, numprocs-1
+!
+!--                         Receive index limits first, then array.
+!--                         Index limits are received in arbitrary order from
+!--                         the PEs.
+                            CALL MPI_RECV( ind(1), 4, MPI_INTEGER,            &
+                                           MPI_ANY_SOURCE, 0, comm2d, status, &
+                                           ierr )
+!
+!--                         Not all PEs have data for YZ-cross-section.
+                            IF ( ind(1) /= -9999 )  THEN
+                               sender = status(MPI_SOURCE)
+                               DEALLOCATE( local_2d )
+                               ALLOCATE( local_2d(ind(1):ind(2),ind(3):ind(4)) )
+                               CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, &
+                                              MPI_REAL, sender, 1, comm2d,  &
+                                              status, ierr )
+                               total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
+                            ENDIF
                          ENDDO
-#endif
-                      ENDIF
-
-                   ELSE
-
-                      IF ( data_output_2d_on_each_pe )  THEN
-!
-!--                      Output of partial arrays on each PE. If the cross section does not reside
-!--                      on the PE, output special index values.
-#if defined( __netcdf )
-                         IF ( myid == 0 )  THEN
-                            WRITE ( 22 )  time_since_reference_point, do2d_xz_time_count(av), av
-                         ENDIF
-#endif
-                         DO  i = 0, io_blocks-1
-                            IF ( i == io_group )  THEN
-                               IF ( ( section(is,s_ind) >= nys .AND. section(is,s_ind) <= nyn )    &
-                                    .OR.  ( section(is,s_ind) == -1 .AND. nys-1 == -1 ) )  THEN
-                                  WRITE (22)  nxl, nxr, nzb_do, nzt_do, nzb, nzt+1
-                                  WRITE (22)  local_2d
-                               ELSE
-                                  WRITE (22)  -1, -1, -1, -1, -1, -1
-                               ENDIF
-                            ENDIF
-#if defined( __parallel )
-                            CALL MPI_BARRIER( comm2d, ierr )
-#endif
-                         ENDDO
+!
+!--                      Output of the total cross-section.
+                         IF ( iso2d_output )  THEN
+                            WRITE (23)  total_2d(0:ny+1,nzb:nzt+1)
+                         ENDIF
+!
+!--                      Relocate the local array for the next loop increment
+                         DEALLOCATE( local_2d )
+                         ALLOCATE( local_2d(nys-1:nyn+1,nzb:nzt+1) )
+
+#if defined( __netcdf )
+                         IF ( netcdf_output )  THEN
+                            nc_stat = NF90_PUT_VAR( id_set_yz(av),             &
+                                                    id_var_do2d(av,if),        &
+                                                    total_2d(0:ny+1,nzb:nzt+1),&
+                               start = (/ is, 1, 1, do2d_yz_time_count(av) /), &
+                                                count = (/ 1, ny+2, nz+2, 1 /) )
+                            IF ( nc_stat /= NF90_NOERR ) &
+                                                  CALL handle_netcdf_error( 60 )
+                         ENDIF
+#endif
 
                       ELSE
 !
-!--                      PE0 receives partial arrays from all processors of the respective cross
-!--                      section and outputs them. Here a barrier has to be set, because otherwise
-!--                      "-MPI- FATAL: Remote protocol queue full" may occur.
-                         CALL MPI_BARRIER( comm2d, ierr )
-
-                         ngp = ( nxr-nxl + 1 ) * ( nzt_do-nzb_do + 1 )
-                         IF ( myid == 0 )  THEN
-!
-!--                         Local array can be relocated directly.
-                            IF ( ( section(is,s_ind) >= nys .AND. section(is,s_ind) <= nyn )  .OR. &
-                                 ( section(is,s_ind) == -1 .AND. nys-1 == -1 ) )  THEN
-                               total_2d(nxl:nxr,nzb_do:nzt_do) = local_2d
-                            ENDIF
-!
-!--                         Receive data from all other PEs.
-                            DO  n = 1, numprocs-1
-!
-!--                            Receive index limits first, then array.
-!--                            Index limits are received in arbitrary order from the PEs.
-                               CALL MPI_RECV( ind(1), 4, MPI_INTEGER, MPI_ANY_SOURCE, 0, comm2d,   &
-                                              status, ierr )
-!
-!--                            Not all PEs have data for XZ-cross-section.
-                               IF ( ind(1) /= -9999 )  THEN
-                                  sender = status(MPI_SOURCE)
-                                  DEALLOCATE( local_2d )
-                                  ALLOCATE( local_2d(ind(1):ind(2), ind(3):ind(4)) )
-                                  CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, MPI_REAL, sender, 1,&
-                                                 comm2d, status, ierr )
-                                  total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
-                               ENDIF
-                            ENDDO
-!
-!--                         Relocate the local array for the next loop increment
-                            DEALLOCATE( local_2d )
-                            ALLOCATE( local_2d(nxl:nxr,nzb_do:nzt_do) )
-
-#if defined( __netcdf )
-                            nc_stat = NF90_PUT_VAR( id_set_xz(av),                                 &
-                                                    id_var_do2d(av,ivar),                          &
-                                                    total_2d(0:nx,nzb_do:nzt_do),                  &
-                                                    start = (/ 1, is, 1, do2d_xz_time_count(av) /),&
-                                                    count = (/ nx+1, 1, nzt_do-nzb_do+1, 1 /) )
-                            CALL netcdf_handle_error( 'data_output_2d', 58 )
-#endif
-
+!--                      If the cross section resides on the PE, send the
+!--                      local index limits, otherwise send -9999 to PE0.
+                         IF ( ( section(is,s)>=nxl .AND. section(is,s)<=nxr )  &
+                           .OR. ( section(is,s) ==  -1  .AND.  nxl-1 == -1 ) ) &
+                         THEN
+                            ind(1) = nys-1; ind(2) = nyn+1
+                            ind(3) = nzb;   ind(4) = nzt+1
                          ELSE
-!
-!--                         If the cross section resides on the PE, send the local index limits,
-!--                         otherwise send -9999 to PE0.
-                            IF ( ( section(is,s_ind) >= nys .AND. section(is,s_ind) <= nyn )  .OR. &
-                                 ( section(is,s_ind) == -1 .AND. nys-1 == -1 ) )  THEN
-                               ind(1) = nxl; ind(2) = nxr
-                               ind(3) = nzb_do;   ind(4) = nzt_do
-                            ELSE
-                               ind(1) = -9999; ind(2) = -9999
-                               ind(3) = -9999; ind(4) = -9999
-                            ENDIF
-                            CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, ierr )
-!
-!--                         If applicable, send data to PE0.
-                            IF ( ind(1) /= -9999 )  THEN
-                               CALL MPI_SEND( local_2d(nxl,nzb_do), ngp, MPI_REAL, 0, 1, comm2d,   &
-                                              ierr )
-                            ENDIF
-                         ENDIF
-!
-!--                      A barrier has to be set, because otherwise some PEs may proceed too fast so
-!--                      that PE0 may receive wrong data on tag 0
-                         CALL MPI_BARRIER( comm2d, ierr )
-                      ENDIF
-
+                            ind(1) = -9999; ind(2) = -9999
+                            ind(3) = -9999; ind(4) = -9999
+                         ENDIF
+                         CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, &
+                                        ierr )
+!
+!--                      If applicable, send data to PE0.
+                         IF ( ind(1) /= -9999 )  THEN
+                            CALL MPI_SEND( local_2d(nys-1,nzb), ngp, MPI_REAL, &
+                                           0, 1, comm2d, ierr )
+                         ENDIF
+                      ENDIF
+!
+!--                   A barrier has to be set, because otherwise some PEs may
+!--                   proceed too fast so that PE0 may receive wrong data on
+!--                   tag 0
+                      CALL MPI_BARRIER( comm2d, ierr )
                    ENDIF
 #else
-#if defined( __netcdf )
-                   nc_stat = NF90_PUT_VAR( id_set_xz(av),                                          &
-                                           id_var_do2d(av,ivar),                                   &
-                                           local_2d(nxl:nxr,nzb_do:nzt_do),                        &
-                                           start = (/ 1, is, 1, do2d_xz_time_count(av) /),         &
-                                           count = (/ nx+1, 1, nzt_do-nzb_do+1, 1 /) )
-                   CALL netcdf_handle_error( 'data_output_2d', 451 )
-#endif
-#endif
-
-                CASE ( 'yz' )
-!
-!--                Update the netCDF yz cross section time axis.
-!--                In case of parallel output, this is only done by PE0 to increase the performance.
-                   IF ( time_since_reference_point /= do2d_yz_last_time(av) )  THEN
-                      do2d_yz_time_count(av) = do2d_yz_time_count(av) + 1
-                      do2d_yz_last_time(av)  = time_since_reference_point
-                      IF ( myid == 0 )  THEN
-                         IF ( .NOT. data_output_2d_on_each_pe  .OR.  netcdf_data_format > 4 )  THEN
-#if defined( __netcdf )
-                            nc_stat = NF90_PUT_VAR( id_set_yz(av),                                 &
-                                                    id_var_time_yz(av),                            &
-                                                    (/ time_since_reference_point /),              &
-                                                    start = (/ do2d_yz_time_count(av) /),          &
-                                                    count = (/ 1 /) )
-                            CALL netcdf_handle_error( 'data_output_2d', 59 )
-#endif
-                         ENDIF
-                      ENDIF
-                   ENDIF
-
-!
-!--                If required, carry out averaging along x
-                   IF ( section(is,s_ind) == -1 )  THEN
-
-                      ALLOCATE( local_2d_l(nys:nyn,nzb_do:nzt_do) )
-                      local_2d_l = 0.0_wp
-                      ngp = ( nyn-nys+1 ) * ( nzt_do-nzb_do+1 )
-!
-!--                   First local averaging on the PE
-                      DO  k = nzb_do, nzt_do
-                         DO  j = nys, nyn
-                            DO  i = nxl, nxr
-                               local_2d_l(j,k) = local_2d_l(j,k) + local_pf(i,j,k)
-                            ENDDO
-                         ENDDO
-                      ENDDO
-#if defined( __parallel )
-!
-!--                   Now do the averaging over all PEs along x
-                      IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-                      CALL MPI_ALLREDUCE( local_2d_l(nys,nzb_do), local_2d(nys,nzb_do), ngp,       &
-                                          MPI_REAL, MPI_SUM, comm1dx, ierr )
-#else
-                      local_2d = local_2d_l
-#endif
-                      local_2d = local_2d / ( nx + 1.0_wp )
-
-                      DEALLOCATE( local_2d_l )
-
-                   ELSE
-!
-!--                   Just store the respective section on the local array (but only if it is
-!--                   available on this PE!)
-                      IF ( section(is,s_ind) >= nxl  .AND.  section(is,s_ind) <= nxr )  THEN
-                         local_2d = local_pf(section(is,s_ind),:,nzb_do:nzt_do)
-                      ENDIF
-
-                   ENDIF
-
-#if defined( __parallel )
-                   IF ( netcdf_data_format > 4 )  THEN
-!
-!--                   Output in netCDF4/HDF5 format.
-!--                   Output only on those PEs where the respective cross sections reside. Cross
-!--                   sections averaged along x are output on the respective first PE along x
-!--                   (myidx=0).
-                      IF ( ( section(is,s_ind) >= nxl .AND. section(is,s_ind) <= nxr )  .OR.       &
-                           ( section(is,s_ind) == -1 .AND. myidx == 0 ) )  THEN
-#if defined( __netcdf )
-!
-!--                      For parallel output, all cross sections are first stored here on a local
-!--                      array and will be written to the output file afterwards to increase the
-!--                      performance.
-                         DO  j = nys, nyn
-                            DO  k = nzb_do, nzt_do
-                               local_2d_sections_l(is,j,k) = local_2d(j,k)
-                            ENDDO
-                         ENDDO
-#endif
-                      ENDIF
-
-                   ELSE
-
-                      IF ( data_output_2d_on_each_pe )  THEN
-!
-!--                      Output of partial arrays on each PE. If the cross section does not reside
-!--                      on the PE, output special index values.
-#if defined( __netcdf )
-                         IF ( myid == 0 )  THEN
-                            WRITE ( 23 )  time_since_reference_point, do2d_yz_time_count(av), av
-                         ENDIF
-#endif
-                         DO  i = 0, io_blocks-1
-                            IF ( i == io_group )  THEN
-                               IF ( ( section(is,s_ind) >= nxl .AND. section(is,s_ind) <= nxr )    &
-                                    .OR.  ( section(is,s_ind) == -1 .AND. nxl-1 == -1 ) )  THEN
-                                  WRITE (23)  nys, nyn, nzb_do, nzt_do, nzb, nzt+1
-                                  WRITE (23)  local_2d
-                               ELSE
-                                  WRITE (23)  -1, -1, -1, -1, -1, -1
-                               ENDIF
-                            ENDIF
-#if defined( __parallel )
-                            CALL MPI_BARRIER( comm2d, ierr )
-#endif
-                         ENDDO
-
+                   IF ( iso2d_output )  THEN
+                      WRITE (23)  local_2d(nys:nyn+1,nzb:nzt+1)
+                   ENDIF
+#if defined( __netcdf )
+                   IF ( netcdf_output )  THEN
+                      nc_stat = NF90_PUT_VAR( id_set_yz(av),                   &
+                                              id_var_do2d(av,if),              &
+                                              local_2d(nys:nyn+1,nzb:nzt+1),   &
+                               start = (/ is, 1, 1, do2d_xz_time_count(av) /), &
+                                              count = (/ 1, ny+2, nz+2, 1 /) )
+                      IF ( nc_stat /= NF90_NOERR )  &
+                                                  CALL handle_netcdf_error( 61 )
+                   ENDIF
+#endif
+#endif
+                   do2d_yz_n = do2d_yz_n + 1
+!
+!--                Write LOCAL-parameter set for ISO2D.
+                   IF ( myid == 0  .AND.  iso2d_output )  THEN
+                      IF ( section(is,s) /= -1 )  THEN
+                         WRITE ( section_chr, '(''x = '',F8.2,'' m  (GP '',I3, &
+                                               &'')'')'                        &
+                               )  section(is,s)*dx, section(is,s)
                       ELSE
-!
-!--                      PE0 receives partial arrays from all processors of the respective cross
-!--                      section and outputs them. Here a barrier has to be set, because otherwise
-!--                      "-MPI- FATAL: Remote protocol queue full" may occur.
-                         CALL MPI_BARRIER( comm2d, ierr )
-
-                         ngp = ( nyn-nys+1 ) * ( nzt_do-nzb_do+1 )
-                         IF ( myid == 0 )  THEN
-!
-!--                         Local array can be relocated directly.
-                            IF ( ( section(is,s_ind) >= nxl .AND. section(is,s_ind) <= nxr )  .OR. &
-                                 ( section(is,s_ind) == -1 .AND. nxl-1 == -1 ) )  THEN
-                               total_2d(nys:nyn,nzb_do:nzt_do) = local_2d
-                            ENDIF
-!
-!--                         Receive data from all other PEs.
-                            DO  n = 1, numprocs-1
-!
-!--                            Receive index limits first, then array.
-!--                            Index limits are received in arbitrary order from the PEs.
-                               CALL MPI_RECV( ind(1), 4, MPI_INTEGER, MPI_ANY_SOURCE, 0, comm2d,   &
-                                              status, ierr )
-!
-!--                            Not all PEs have data for YZ-cross-section.
-                               IF ( ind(1) /= -9999 )  THEN
-                                  sender = status(MPI_SOURCE)
-                                  DEALLOCATE( local_2d )
-                                  ALLOCATE( local_2d(ind(1):ind(2), ind(3):ind(4)) )
-                                  CALL MPI_RECV( local_2d(ind(1),ind(3)), ngp, MPI_REAL, sender, 1,&
-                                                 comm2d, status, ierr )
-                                  total_2d(ind(1):ind(2),ind(3):ind(4)) = local_2d
-                               ENDIF
-                            ENDDO
-!
-!--                         Relocate the local array for the next loop increment
-                            DEALLOCATE( local_2d )
-                            ALLOCATE( local_2d(nys:nyn,nzb_do:nzt_do) )
-
-#if defined( __netcdf )
-                            nc_stat = NF90_PUT_VAR( id_set_yz(av),                                 &
-                                                    id_var_do2d(av,ivar),                          &
-                                                    total_2d(0:ny,nzb_do:nzt_do),                  &
-                                                    start = (/ is, 1, 1, do2d_yz_time_count(av) /),&
-                                                    count = (/ 1, ny+1, nzt_do-nzb_do+1, 1 /) )
-                            CALL netcdf_handle_error( 'data_output_2d', 61 )
-#endif
-
-                         ELSE
-!
-!--                         If the cross section resides on the PE, send the
-!--                         local index limits, otherwise send -9999 to PE0.
-                            IF ( ( section(is,s_ind) >= nxl .AND. section(is,s_ind) <= nxr )  .OR. &
-                                 ( section(is,s_ind) == -1 .AND. nxl-1 == -1 ) )  THEN
-                               ind(1) = nys; ind(2) = nyn
-                               ind(3) = nzb_do;   ind(4) = nzt_do
-                            ELSE
-                               ind(1) = -9999; ind(2) = -9999
-                               ind(3) = -9999; ind(4) = -9999
-                            ENDIF
-                            CALL MPI_SEND( ind(1), 4, MPI_INTEGER, 0, 0, comm2d, ierr )
-!
-!--                         If applicable, send data to PE0.
-                            IF ( ind(1) /= -9999 )  THEN
-                               CALL MPI_SEND( local_2d(nys,nzb_do), ngp, MPI_REAL, 0, 1, comm2d,   &
-                                              ierr )
-                            ENDIF
-                         ENDIF
-!
-!--                      A barrier has to be set, because otherwise some PEs may proceed too fast so
-!--                      that PE0 may receive wrong data on tag 0
-                         CALL MPI_BARRIER( comm2d, ierr )
-                      ENDIF
-
-                   ENDIF
-#else
-#if defined( __netcdf )
-                   nc_stat = NF90_PUT_VAR( id_set_yz(av),                                          &
-                                           id_var_do2d(av,ivar),                                   &
-                                           local_2d(nys:nyn,nzb_do:nzt_do),                        &
-                                           start = (/ is, 1, 1, do2d_xz_time_count(av) /),         &
-                                           count = (/ 1, ny+1, nzt_do-nzb_do+1, 1 /) )
-                   CALL netcdf_handle_error( 'data_output_2d', 452 )
-#endif
-#endif
+                         section_chr = 'averaged along x'
+                      ENDIF
+                      IF ( av == 0 )  THEN
+                         rtext = TRIM( do2d(av,if) ) // '  t = ' //    &
+                                 TRIM( simulated_time_chr ) // '  ' // &
+                                 TRIM( section_chr )
+                      ELSE
+                         rtext = TRIM( do2d(av,if) ) // '  averaged t = ' // &
+                                 TRIM( simulated_time_chr ) // '  ' //       &
+                                 TRIM( section_chr )
+                      ENDIF
+                      WRITE (29,LOCAL)
+                   ENDIF
 
              END SELECT
